/* WebFont.c generated by valac 0.56.17, the Vala compiler
 * generated from WebFont.vala, do not modify */

/* WebFont.vala
 *
 * Copyright (C) 2020-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <glib/gstdio.h>
#include "font-manager.h"
#include <json-glib/json-glib.h>
#include <glib/gi18n-lib.h>

#define FONT_MANAGER_GOOGLE_FONTS_FONT_FACE "@font-face { font-family: '%s'; font-style: %s; font-weight: %i; src: " \
"local('%s'), local('%s'), url(%s) format('truetype'); }"
#define FONT_MANAGER_GOOGLE_FONTS_GET "GET"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE
} FontManagerGoogleFontsFileStatus;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FILE_STATUS (font_manager_google_fonts_file_status_get_type ())

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT (font_manager_google_fonts_font_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FONT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))

typedef struct _FontManagerGoogleFontsFont FontManagerGoogleFontsFont;
typedef struct _FontManagerGoogleFontsFontClass FontManagerGoogleFontsFontClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FontManagerGoogleFontsDownloadFontFilesData FontManagerGoogleFontsDownloadFontFilesData;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY (font_manager_google_fonts_family_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))

typedef struct _FontManagerGoogleFontsFamily FontManagerGoogleFontsFamily;
typedef struct _FontManagerGoogleFontsFamilyClass FontManagerGoogleFontsFamilyClass;
typedef struct _FontManagerGoogleFontsFamilyPrivate FontManagerGoogleFontsFamilyPrivate;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_NUM_PROPERTIES];
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block80Data Block80Data;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block81Data Block81Data;
typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_THIN = 100,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_LIGHT = 200,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_LIGHT = 300,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR = 400,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_MEDIUM = 500,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_SEMI_BOLD = 600,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BOLD = 700,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_BOLD = 800,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BLACK = 900
} FontManagerGoogleFontsWeight;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_WEIGHT (font_manager_google_fonts_weight_get_type ())
typedef struct _Block82Data Block82Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _FontManagerGoogleFontsFontPrivate FontManagerGoogleFontsFontPrivate;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_FONT_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerGoogleFontsDownloadFontFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FontManagerGoogleFontsFont** fonts;
	gint fonts_length1;
	gboolean result;
	SoupSession* session;
	SoupSession* _tmp0_;
	gboolean retval;
	FontManagerGoogleFontsFont** font_collection;
	gint font_collection_length1;
	gint _font_collection_size_;
	gint font_it;
	FontManagerGoogleFontsFont* _tmp1_;
	FontManagerGoogleFontsFont* font;
	gchar* font_dir;
	gchar* _tmp2_;
	gchar* _tmp3_;
	FontManagerGoogleFontsFont* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* filename;
	FontManagerGoogleFontsFont* _tmp11_;
	gchar* _tmp12_;
	gchar* filepath;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	SoupMessage* message;
	FontManagerGoogleFontsFont* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	SoupMessage* _tmp19_;
	GBytes* bytes;
	SoupSession* _tmp20_;
	SoupMessage* _tmp21_;
	GBytes* _tmp22_;
	GBytes* _tmp23_;
	GFile* font_file;
	const gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	GFileOutputStream* stream;
	GFile* _tmp28_;
	GFileOutputStream* _tmp29_;
	GFileOutputStream* _tmp30_;
	GBytes* _tmp31_;
	GFileOutputStream* _tmp32_;
	GError* e;
	const gchar* _tmp33_;
	GError* _tmp34_;
	const gchar* _tmp35_;
	GError* _vala1_e;
	const gchar* _tmp36_;
	SoupMessage* _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	GError* _tmp40_;
	const gchar* _tmp41_;
	GError* _inner_error0_;
};

struct _FontManagerGoogleFontsFamily {
	GObject parent_instance;
	FontManagerGoogleFontsFamilyPrivate * priv;
};

struct _FontManagerGoogleFontsFamilyClass {
	GObjectClass parent_class;
};

struct _FontManagerGoogleFontsFamilyPrivate {
	gchar* _family;
	gchar* _category;
	GPtrArray* _variants;
	FontManagerStringSet* _subsets;
	gint _count;
	gint _version;
};

struct _Block80Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	JsonObject* filelist;
};

struct _Block81Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	FontManagerGoogleFontsFont* _result_;
};

struct _Block82Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	GString* builder;
};

struct _FontManagerGoogleFontsFont {
	GObject parent_instance;
	FontManagerGoogleFontsFontPrivate * priv;
};

struct _FontManagerGoogleFontsFontClass {
	GObjectClass parent_class;
};

struct _FontManagerGoogleFontsFontPrivate {
	gchar* _family;
	gchar* _url;
	gint _weight;
	gboolean _italic;
	gint _version;
	FontManagerStringSet* _subsets;
};

static gint FontManagerGoogleFontsFamily_private_offset;
static gpointer font_manager_google_fonts_family_parent_class = NULL;
static gint FontManagerGoogleFontsFont_private_offset;
static gpointer font_manager_google_fonts_font_parent_class = NULL;

VALA_EXTERN GType font_manager_google_fonts_file_status_get_type (void) G_GNUC_CONST ;
static void font_manager_google_fonts_download_font_files_data_free (gpointer _data);
VALA_EXTERN GType font_manager_google_fonts_font_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFont, g_object_unref)
VALA_EXTERN void font_manager_google_fonts_download_font_files (FontManagerGoogleFontsFont** fonts,
                                                    gint fonts_length1,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
VALA_EXTERN gboolean font_manager_google_fonts_download_font_files_finish (GAsyncResult* _res_);
static gboolean font_manager_google_fonts_download_font_files_co (FontManagerGoogleFontsDownloadFontFilesData* _data_);
VALA_EXTERN gchar* font_manager_google_fonts_get_font_directory (void);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_get_filename (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_url (FontManagerGoogleFontsFont* self);
static gboolean _font_manager_google_fonts_download_font_files_co_gsource_func (gpointer self);
VALA_EXTERN GType font_manager_google_fonts_family_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFamily, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsFamily* font_manager_google_fonts_family_new (JsonObject* source);
VALA_EXTERN FontManagerGoogleFontsFamily* font_manager_google_fonts_family_construct (GType object_type,
                                                                          JsonObject* source);
static Block80Data* block80_data_ref (Block80Data* _data80_);
static void block80_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_google_fonts_family_set_family (FontManagerGoogleFontsFamily* self,
                                                  const gchar* value);
VALA_EXTERN void font_manager_google_fonts_family_set_category (FontManagerGoogleFontsFamily* self,
                                                    const gchar* value);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN void font_manager_google_fonts_family_set_variants (FontManagerGoogleFontsFamily* self,
                                                    GPtrArray* value);
VALA_EXTERN void font_manager_google_fonts_family_set_subsets (FontManagerGoogleFontsFamily* self,
                                                   FontManagerStringSet* value);
static void __lambda192_ (Block80Data* _data80_,
                   JsonArray* array,
                   guint index,
                   JsonNode* node);
VALA_EXTERN const gchar* font_manager_google_fonts_family_get_family (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_family_get_subsets (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_font_new (const gchar* family,
                                                                const gchar* variant,
                                                                const gchar* url,
                                                                FontManagerStringSet* subsets);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_font_construct (GType object_type,
                                                                      const gchar* family,
                                                                      const gchar* variant,
                                                                      const gchar* url,
                                                                      FontManagerStringSet* subsets);
VALA_EXTERN GPtrArray* font_manager_google_fonts_family_get_variants (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gint font_manager_google_fonts_family_get_count (FontManagerGoogleFontsFamily* self);
static void font_manager_google_fonts_family_set_count (FontManagerGoogleFontsFamily* self,
                                                 gint value);
static void ___lambda192__json_array_foreach (JsonArray* array,
                                       guint index_,
                                       JsonNode* element_node,
                                       gpointer self);
static void __lambda193_ (FontManagerGoogleFontsFamily* self,
                   JsonArray* array,
                   guint index,
                   JsonNode* node);
static void ___lambda193__json_array_foreach (JsonArray* array,
                                       guint index_,
                                       JsonNode* element_node,
                                       gpointer self);
static void font_manager_google_fonts_family_set_version (FontManagerGoogleFontsFamily* self,
                                                   gint value);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_family_get_default_variant (FontManagerGoogleFontsFamily* self);
static Block81Data* block81_data_ref (Block81Data* _data81_);
static void block81_data_unref (void * _userdata_);
static void __lambda194_ (Block81Data* _data81_,
                   FontManagerGoogleFontsFont* variant);
VALA_EXTERN gboolean font_manager_google_fonts_font_get_italic (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self);
VALA_EXTERN GType font_manager_google_fonts_weight_get_type (void) G_GNUC_CONST ;
static void ___lambda194__gfunc (gconstpointer data,
                          gpointer self);
VALA_EXTERN gchar* font_manager_google_fonts_family_to_stylesheet (FontManagerGoogleFontsFamily* self);
static Block82Data* block82_data_ref (Block82Data* _data82_);
static void block82_data_unref (void * _userdata_);
static void __lambda195_ (Block82Data* _data82_,
                   FontManagerGoogleFontsFont* variant);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self);
static void ___lambda195__gfunc (gconstpointer data,
                          gpointer self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_family_get_installation_status (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_font_get_installation_status (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_family_get_category (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gint font_manager_google_fonts_family_get_version (FontManagerGoogleFontsFamily* self);
static void font_manager_google_fonts_family_finalize (GObject * obj);
static GType font_manager_google_fonts_family_get_type_once (void);
static void _vala_font_manager_google_fonts_family_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_font_manager_google_fonts_family_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
VALA_EXTERN void font_manager_google_fonts_font_set_italic (FontManagerGoogleFontsFont* self,
                                                gboolean value);
VALA_EXTERN void font_manager_google_fonts_font_set_weight (FontManagerGoogleFontsFont* self,
                                                gint value);
static void font_manager_google_fonts_font_set_version (FontManagerGoogleFontsFont* self,
                                                 gint value);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_display_name (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_weight_to_translatable_string (FontManagerGoogleFontsWeight self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_description (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_weight_to_string (FontManagerGoogleFontsWeight self);
VALA_EXTERN gint font_manager_google_fonts_font_get_version (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_font_set_family (FontManagerGoogleFontsFont* self,
                                                const gchar* value);
VALA_EXTERN void font_manager_google_fonts_font_set_url (FontManagerGoogleFontsFont* self,
                                             const gchar* value);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_font_set_subsets (FontManagerGoogleFontsFont* self,
                                                 FontManagerStringSet* value);
static void font_manager_google_fonts_font_finalize (GObject * obj);
static GType font_manager_google_fonts_font_get_type_once (void);
static void _vala_font_manager_google_fonts_font_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_font_manager_google_fonts_font_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_file_status_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED", "not-installed"}, {FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED", "installed"}, {FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE", "requires-update"}, {0, NULL, NULL}};
	GType font_manager_google_fonts_file_status_type_id;
	font_manager_google_fonts_file_status_type_id = g_enum_register_static ("FontManagerGoogleFontsFileStatus", values);
	return font_manager_google_fonts_file_status_type_id;
}

GType
font_manager_google_fonts_file_status_get_type (void)
{
	static volatile gsize font_manager_google_fonts_file_status_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_file_status_type_id__once)) {
		GType font_manager_google_fonts_file_status_type_id;
		font_manager_google_fonts_file_status_type_id = font_manager_google_fonts_file_status_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_file_status_type_id__once, font_manager_google_fonts_file_status_type_id);
	}
	return font_manager_google_fonts_file_status_type_id__once;
}

static void
font_manager_google_fonts_download_font_files_data_free (gpointer _data)
{
	FontManagerGoogleFontsDownloadFontFilesData* _data_;
	_data_ = _data;
	g_slice_free (FontManagerGoogleFontsDownloadFontFilesData, _data_);
}

void
font_manager_google_fonts_download_font_files (FontManagerGoogleFontsFont** fonts,
                                               gint fonts_length1,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	FontManagerGoogleFontsDownloadFontFilesData* _data_;
	_data_ = g_slice_new0 (FontManagerGoogleFontsDownloadFontFilesData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, font_manager_google_fonts_download_font_files_data_free);
	_data_->fonts = fonts;
	_data_->fonts_length1 = fonts_length1;
	font_manager_google_fonts_download_font_files_co (_data_);
}

gboolean
font_manager_google_fonts_download_font_files_finish (GAsyncResult* _res_)
{
	gboolean result;
	FontManagerGoogleFontsDownloadFontFilesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/font-manager/web/google/WebFont.vala"
	return self ? g_object_ref (self) : NULL;
#line 460 "WebFont.c"
}

static gboolean
_font_manager_google_fonts_download_font_files_co_gsource_func (gpointer self)
{
	gboolean result;
	result = font_manager_google_fonts_download_font_files_co (self);
#line 67 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 470 "WebFont.c"
}

static gboolean
font_manager_google_fonts_download_font_files_co (FontManagerGoogleFontsDownloadFontFilesData* _data_)
{
#line 33 "../src/font-manager/web/google/WebFont.vala"
	switch (_data_->_state_) {
#line 33 "../src/font-manager/web/google/WebFont.vala"
		case 0:
#line 480 "WebFont.c"
		goto _state_0;
#line 33 "../src/font-manager/web/google/WebFont.vala"
		case 1:
#line 484 "WebFont.c"
		goto _state_1;
		default:
#line 33 "../src/font-manager/web/google/WebFont.vala"
		g_assert_not_reached ();
#line 489 "WebFont.c"
	}
	_state_0:
#line 34 "../src/font-manager/web/google/WebFont.vala"
	_data_->_tmp0_ = soup_session_new ();
#line 34 "../src/font-manager/web/google/WebFont.vala"
	_data_->session = _data_->_tmp0_;
#line 35 "../src/font-manager/web/google/WebFont.vala"
	_data_->retval = TRUE;
#line 498 "WebFont.c"
	{
#line 36 "../src/font-manager/web/google/WebFont.vala"
		_data_->font_collection_length1 = 0;
#line 36 "../src/font-manager/web/google/WebFont.vala"
		_data_->_font_collection_size_ = 0;
#line 36 "../src/font-manager/web/google/WebFont.vala"
		_data_->font_collection = _data_->fonts;
#line 36 "../src/font-manager/web/google/WebFont.vala"
		_data_->font_collection_length1 = _data_->fonts_length1;
#line 36 "../src/font-manager/web/google/WebFont.vala"
		for (_data_->font_it = 0; _data_->font_it < _data_->font_collection_length1; _data_->font_it = _data_->font_it + 1) {
#line 36 "../src/font-manager/web/google/WebFont.vala"
			_data_->_tmp1_ = _g_object_ref0 (_data_->font_collection[_data_->font_it]);
#line 36 "../src/font-manager/web/google/WebFont.vala"
			_data_->font = _data_->_tmp1_;
#line 514 "WebFont.c"
			{
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp2_ = font_manager_google_fonts_get_font_directory ();
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp3_ = _data_->_tmp2_;
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp4_ = _data_->font;
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp5_ = font_manager_google_fonts_font_get_family (_data_->_tmp4_);
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp6_ = _data_->_tmp5_;
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp7_ = g_build_filename (_data_->_tmp3_, _data_->_tmp6_, NULL);
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp8_ = _data_->_tmp7_;
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_g_free0 (_data_->_tmp3_);
#line 37 "../src/font-manager/web/google/WebFont.vala"
				_data_->font_dir = _data_->_tmp8_;
#line 38 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp9_ = _data_->font_dir;
#line 38 "../src/font-manager/web/google/WebFont.vala"
				if (g_mkdir_with_parents (_data_->_tmp9_, 0755) != 0) {
#line 39 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp10_ = _data_->font_dir;
#line 39 "../src/font-manager/web/google/WebFont.vala"
					g_warning ("WebFont.vala:39: Failed to create directory : %s", _data_->_tmp10_);
#line 40 "../src/font-manager/web/google/WebFont.vala"
					_data_->result = FALSE;
#line 40 "../src/font-manager/web/google/WebFont.vala"
					_g_free0 (_data_->font_dir);
#line 40 "../src/font-manager/web/google/WebFont.vala"
					_g_object_unref0 (_data_->font);
#line 40 "../src/font-manager/web/google/WebFont.vala"
					_g_object_unref0 (_data_->session);
#line 40 "../src/font-manager/web/google/WebFont.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 40 "../src/font-manager/web/google/WebFont.vala"
					if (_data_->_state_ != 0) {
#line 40 "../src/font-manager/web/google/WebFont.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 40 "../src/font-manager/web/google/WebFont.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 558 "WebFont.c"
						}
					}
#line 40 "../src/font-manager/web/google/WebFont.vala"
					g_object_unref (_data_->_async_result);
#line 40 "../src/font-manager/web/google/WebFont.vala"
					return FALSE;
#line 565 "WebFont.c"
				}
#line 42 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp11_ = _data_->font;
#line 42 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp12_ = font_manager_google_fonts_font_get_filename (_data_->_tmp11_);
#line 42 "../src/font-manager/web/google/WebFont.vala"
				_data_->filename = _data_->_tmp12_;
#line 43 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp13_ = _data_->font_dir;
#line 43 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp14_ = _data_->filename;
#line 43 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp15_ = g_build_filename (_data_->_tmp13_, _data_->_tmp14_, NULL);
#line 43 "../src/font-manager/web/google/WebFont.vala"
				_data_->filepath = _data_->_tmp15_;
#line 44 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp16_ = _data_->font;
#line 44 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp17_ = font_manager_google_fonts_font_get_url (_data_->_tmp16_);
#line 44 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp18_ = _data_->_tmp17_;
#line 44 "../src/font-manager/web/google/WebFont.vala"
				_data_->_tmp19_ = soup_message_new (FONT_MANAGER_GOOGLE_FONTS_GET, _data_->_tmp18_);
#line 44 "../src/font-manager/web/google/WebFont.vala"
				_data_->message = _data_->_tmp19_;
#line 591 "WebFont.c"
				{
#line 46 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp20_ = _data_->session;
#line 46 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp21_ = _data_->message;
#line 46 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp22_ = soup_session_send_and_read (_data_->_tmp20_, _data_->_tmp21_, NULL, &_data_->_inner_error0_);
#line 46 "../src/font-manager/web/google/WebFont.vala"
					_data_->bytes = _data_->_tmp22_;
#line 46 "../src/font-manager/web/google/WebFont.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 603 "WebFont.c"
						goto __catch0_g_error;
					}
#line 47 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp23_ = _data_->bytes;
#line 47 "../src/font-manager/web/google/WebFont.vala"
					_vala_assert (_data_->_tmp23_ != NULL, "bytes != null");
#line 48 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp24_ = _data_->filepath;
#line 48 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp25_ = g_file_new_for_path (_data_->_tmp24_);
#line 48 "../src/font-manager/web/google/WebFont.vala"
					_data_->font_file = _data_->_tmp25_;
#line 50 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp26_ = _data_->font_file;
#line 50 "../src/font-manager/web/google/WebFont.vala"
					if (g_file_query_exists (_data_->_tmp26_, NULL)) {
#line 51 "../src/font-manager/web/google/WebFont.vala"
						_data_->_tmp27_ = _data_->font_file;
#line 51 "../src/font-manager/web/google/WebFont.vala"
						g_file_delete (_data_->_tmp27_, NULL, &_data_->_inner_error0_);
#line 51 "../src/font-manager/web/google/WebFont.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 51 "../src/font-manager/web/google/WebFont.vala"
							_g_object_unref0 (_data_->font_file);
#line 51 "../src/font-manager/web/google/WebFont.vala"
							_g_bytes_unref0 (_data_->bytes);
#line 630 "WebFont.c"
							goto __catch0_g_error;
						}
					}
#line 52 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp28_ = _data_->font_file;
#line 52 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp29_ = g_file_create (_data_->_tmp28_, G_FILE_CREATE_PRIVATE, NULL, &_data_->_inner_error0_);
#line 52 "../src/font-manager/web/google/WebFont.vala"
					_data_->stream = _data_->_tmp29_;
#line 52 "../src/font-manager/web/google/WebFont.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 52 "../src/font-manager/web/google/WebFont.vala"
						_g_object_unref0 (_data_->font_file);
#line 52 "../src/font-manager/web/google/WebFont.vala"
						_g_bytes_unref0 (_data_->bytes);
#line 646 "WebFont.c"
						goto __catch0_g_error;
					}
					{
#line 54 "../src/font-manager/web/google/WebFont.vala"
						_data_->_tmp30_ = _data_->stream;
#line 54 "../src/font-manager/web/google/WebFont.vala"
						_data_->_tmp31_ = _data_->bytes;
#line 54 "../src/font-manager/web/google/WebFont.vala"
						g_output_stream_write_bytes ((GOutputStream*) _data_->_tmp30_, _data_->_tmp31_, NULL, &_data_->_inner_error0_);
#line 54 "../src/font-manager/web/google/WebFont.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 658 "WebFont.c"
							goto __catch1_g_error;
						}
#line 55 "../src/font-manager/web/google/WebFont.vala"
						_data_->_tmp32_ = _data_->stream;
#line 55 "../src/font-manager/web/google/WebFont.vala"
						g_output_stream_close ((GOutputStream*) _data_->_tmp32_, NULL, &_data_->_inner_error0_);
#line 55 "../src/font-manager/web/google/WebFont.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 667 "WebFont.c"
							goto __catch1_g_error;
						}
					}
					goto __finally1;
					__catch1_g_error:
					{
#line 53 "../src/font-manager/web/google/WebFont.vala"
						_data_->e = _data_->_inner_error0_;
#line 53 "../src/font-manager/web/google/WebFont.vala"
						_data_->_inner_error0_ = NULL;
#line 57 "../src/font-manager/web/google/WebFont.vala"
						_data_->retval = FALSE;
#line 58 "../src/font-manager/web/google/WebFont.vala"
						_data_->_tmp33_ = _data_->filepath;
#line 58 "../src/font-manager/web/google/WebFont.vala"
						_data_->_tmp34_ = _data_->e;
#line 58 "../src/font-manager/web/google/WebFont.vala"
						_data_->_tmp35_ = _data_->_tmp34_->message;
#line 58 "../src/font-manager/web/google/WebFont.vala"
						g_warning ("WebFont.vala:58: Failed to write data to file : %s : %s", _data_->_tmp33_, _data_->_tmp35_);
#line 53 "../src/font-manager/web/google/WebFont.vala"
						_g_error_free0 (_data_->e);
#line 690 "WebFont.c"
					}
					__finally1:
#line 53 "../src/font-manager/web/google/WebFont.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 53 "../src/font-manager/web/google/WebFont.vala"
						_g_object_unref0 (_data_->stream);
#line 53 "../src/font-manager/web/google/WebFont.vala"
						_g_object_unref0 (_data_->font_file);
#line 53 "../src/font-manager/web/google/WebFont.vala"
						_g_bytes_unref0 (_data_->bytes);
#line 701 "WebFont.c"
						goto __catch0_g_error;
					}
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_object_unref0 (_data_->stream);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_object_unref0 (_data_->font_file);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_bytes_unref0 (_data_->bytes);
#line 710 "WebFont.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_data_->_vala1_e = _data_->_inner_error0_;
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_data_->_inner_error0_ = NULL;
#line 61 "../src/font-manager/web/google/WebFont.vala"
					_data_->retval = FALSE;
#line 62 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp36_ = _data_->filename;
#line 62 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp37_ = _data_->message;
#line 62 "../src/font-manager/web/google/WebFont.vala"
					g_object_get (_data_->_tmp37_, "status-code", &_data_->_tmp38_, NULL);
#line 62 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp39_ = _data_->_tmp38_;
#line 62 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp40_ = _data_->_vala1_e;
#line 62 "../src/font-manager/web/google/WebFont.vala"
					_data_->_tmp41_ = _data_->_tmp40_->message;
#line 62 "../src/font-manager/web/google/WebFont.vala"
					g_warning ("WebFont.vala:62: Failed to read data for : %s :: %i :: %s", _data_->_tmp36_, (gint) _data_->_tmp39_, _data_->_tmp41_);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_error_free0 (_data_->_vala1_e);
#line 737 "WebFont.c"
				}
				__finally0:
#line 45 "../src/font-manager/web/google/WebFont.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_object_unref0 (_data_->message);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_free0 (_data_->filepath);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_free0 (_data_->filename);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_free0 (_data_->font_dir);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_object_unref0 (_data_->font);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					_g_object_unref0 (_data_->session);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					g_object_unref (_data_->_async_result);
#line 45 "../src/font-manager/web/google/WebFont.vala"
					return FALSE;
#line 762 "WebFont.c"
				}
#line 67 "../src/font-manager/web/google/WebFont.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _font_manager_google_fonts_download_font_files_co_gsource_func, _data_, NULL);
#line 68 "../src/font-manager/web/google/WebFont.vala"
				_data_->_state_ = 1;
#line 68 "../src/font-manager/web/google/WebFont.vala"
				return FALSE;
#line 770 "WebFont.c"
				_state_1:
				;
#line 36 "../src/font-manager/web/google/WebFont.vala"
				_g_object_unref0 (_data_->message);
#line 36 "../src/font-manager/web/google/WebFont.vala"
				_g_free0 (_data_->filepath);
#line 36 "../src/font-manager/web/google/WebFont.vala"
				_g_free0 (_data_->filename);
#line 36 "../src/font-manager/web/google/WebFont.vala"
				_g_free0 (_data_->font_dir);
#line 36 "../src/font-manager/web/google/WebFont.vala"
				_g_object_unref0 (_data_->font);
#line 783 "WebFont.c"
			}
		}
	}
#line 70 "../src/font-manager/web/google/WebFont.vala"
	_data_->result = _data_->retval;
#line 70 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (_data_->session);
#line 70 "../src/font-manager/web/google/WebFont.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 70 "../src/font-manager/web/google/WebFont.vala"
	if (_data_->_state_ != 0) {
#line 70 "../src/font-manager/web/google/WebFont.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 70 "../src/font-manager/web/google/WebFont.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 799 "WebFont.c"
		}
	}
#line 70 "../src/font-manager/web/google/WebFont.vala"
	g_object_unref (_data_->_async_result);
#line 70 "../src/font-manager/web/google/WebFont.vala"
	return FALSE;
#line 806 "WebFont.c"
}

static inline gpointer
font_manager_google_fonts_family_get_instance_private (FontManagerGoogleFontsFamily* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsFamily_private_offset);
}

static Block80Data*
block80_data_ref (Block80Data* _data80_)
{
#line 82 "../src/font-manager/web/google/WebFont.vala"
	g_atomic_int_inc (&_data80_->_ref_count_);
#line 82 "../src/font-manager/web/google/WebFont.vala"
	return _data80_;
#line 822 "WebFont.c"
}

static void
block80_data_unref (void * _userdata_)
{
	Block80Data* _data80_;
	_data80_ = (Block80Data*) _userdata_;
#line 82 "../src/font-manager/web/google/WebFont.vala"
	if (g_atomic_int_dec_and_test (&_data80_->_ref_count_)) {
#line 832 "WebFont.c"
		FontManagerGoogleFontsFamily* self;
#line 82 "../src/font-manager/web/google/WebFont.vala"
		self = _data80_->self;
#line 82 "../src/font-manager/web/google/WebFont.vala"
		_json_object_unref0 (_data80_->filelist);
#line 82 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self);
#line 82 "../src/font-manager/web/google/WebFont.vala"
		g_slice_free (Block80Data, _data80_);
#line 842 "WebFont.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 85 "../src/font-manager/web/google/WebFont.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 851 "WebFont.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 87 "../src/font-manager/web/google/WebFont.vala"
	return self ? json_object_ref (self) : NULL;
#line 859 "WebFont.c"
}

static void
__lambda192_ (Block80Data* _data80_,
              JsonArray* array,
              guint index,
              JsonNode* node)
{
	FontManagerGoogleFontsFamily* self;
	gchar* entry = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	FontManagerGoogleFontsFont* variant = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	FontManagerStringSet* _tmp4_;
	FontManagerGoogleFontsFont* _tmp5_;
	GPtrArray* _tmp6_;
	FontManagerGoogleFontsFont* _tmp7_;
	gint _tmp8_;
#line 88 "../src/font-manager/web/google/WebFont.vala"
	self = _data80_->self;
#line 88 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (array != NULL);
#line 88 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (node != NULL);
#line 89 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = json_node_get_string (node);
#line 89 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 89 "../src/font-manager/web/google/WebFont.vala"
	entry = _tmp1_;
#line 90 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = self->priv->_family;
#line 90 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = json_object_get_string_member (_data80_->filelist, entry);
#line 90 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = self->priv->_subsets;
#line 90 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = font_manager_google_fonts_font_new (_tmp2_, entry, _tmp3_, _tmp4_);
#line 90 "../src/font-manager/web/google/WebFont.vala"
	variant = _tmp5_;
#line 91 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_variants;
#line 91 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = _g_object_ref0 (variant);
#line 91 "../src/font-manager/web/google/WebFont.vala"
	g_ptr_array_insert (_tmp6_, (gint) index, _tmp7_);
#line 92 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = self->priv->_count;
#line 92 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_count (self, _tmp8_ + 1);
#line 88 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (variant);
#line 88 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (entry);
#line 916 "WebFont.c"
}

static void
___lambda192__json_array_foreach (JsonArray* array,
                                  guint index_,
                                  JsonNode* element_node,
                                  gpointer self)
{
#line 88 "../src/font-manager/web/google/WebFont.vala"
	__lambda192_ (self, array, index_, element_node);
#line 927 "WebFont.c"
}

static void
__lambda193_ (FontManagerGoogleFontsFamily* self,
              JsonArray* array,
              guint index,
              JsonNode* node)
{
	FontManagerStringSet* _tmp0_;
	const gchar* _tmp1_;
#line 94 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (array != NULL);
#line 94 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (node != NULL);
#line 95 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_subsets;
#line 95 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = json_node_get_string (node);
#line 95 "../src/font-manager/web/google/WebFont.vala"
	font_manager_string_set_add (_tmp0_, _tmp1_);
#line 948 "WebFont.c"
}

static void
___lambda193__json_array_foreach (JsonArray* array,
                                  guint index_,
                                  JsonNode* element_node,
                                  gpointer self)
{
#line 94 "../src/font-manager/web/google/WebFont.vala"
	__lambda193_ ((FontManagerGoogleFontsFamily*) self, array, index_, element_node);
#line 959 "WebFont.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 981 "WebFont.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 985 "WebFont.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 991 "WebFont.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 995 "WebFont.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 999 "WebFont.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1007 "WebFont.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1035 "WebFont.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1044 "WebFont.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1058 "WebFont.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1067 "WebFont.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1081 "WebFont.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1090 "WebFont.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1099 "WebFont.c"
}

FontManagerGoogleFontsFamily*
font_manager_google_fonts_family_construct (GType object_type,
                                            JsonObject* source)
{
	FontManagerGoogleFontsFamily * self = NULL;
	Block80Data* _data80_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GPtrArray* _tmp2_;
	GPtrArray* _tmp3_;
	FontManagerStringSet* _tmp4_;
	FontManagerStringSet* _tmp5_;
	JsonObject* _tmp6_;
	JsonObject* _tmp7_;
	JsonArray* _tmp8_;
	JsonArray* _tmp9_;
	gchar** _version = NULL;
	GPtrArray* _tmp10_;
	gconstpointer _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _version_length1;
	gint __version_size_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 82 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 82 "../src/font-manager/web/google/WebFont.vala"
	_data80_ = g_slice_new0 (Block80Data);
#line 82 "../src/font-manager/web/google/WebFont.vala"
	_data80_->_ref_count_ = 1;
#line 82 "../src/font-manager/web/google/WebFont.vala"
	self = (FontManagerGoogleFontsFamily*) g_object_new (object_type, NULL);
#line 82 "../src/font-manager/web/google/WebFont.vala"
	_data80_->self = g_object_ref (self);
#line 83 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = json_object_get_string_member (source, "family");
#line 83 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_family (self, _tmp0_);
#line 84 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = json_object_get_string_member (source, "category");
#line 84 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_category (self, _tmp1_);
#line 85 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 85 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = _tmp2_;
#line 85 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_variants (self, _tmp3_);
#line 85 "../src/font-manager/web/google/WebFont.vala"
	_g_ptr_array_unref0 (_tmp3_);
#line 86 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = font_manager_string_set_new ();
#line 86 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = _tmp4_;
#line 86 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_subsets (self, _tmp5_);
#line 86 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (_tmp5_);
#line 87 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = json_object_get_object_member (source, "files");
#line 87 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = _json_object_ref0 (_tmp6_);
#line 87 "../src/font-manager/web/google/WebFont.vala"
	_data80_->filelist = _tmp7_;
#line 88 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = json_object_get_array_member (source, "variants");
#line 88 "../src/font-manager/web/google/WebFont.vala"
	json_array_foreach_element (_tmp8_, ___lambda192__json_array_foreach, _data80_);
#line 94 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = json_object_get_array_member (source, "subsets");
#line 94 "../src/font-manager/web/google/WebFont.vala"
	json_array_foreach_element (_tmp9_, ___lambda193__json_array_foreach, self);
#line 97 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = self->priv->_variants;
#line 97 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = g_ptr_array_index (_tmp10_, (guint) 0);
#line 97 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = font_manager_google_fonts_font_get_url ((FontManagerGoogleFontsFont*) _tmp11_);
#line 97 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 97 "../src/font-manager/web/google/WebFont.vala"
	_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "/", 0);
#line 97 "../src/font-manager/web/google/WebFont.vala"
	_version = _tmp15_;
#line 97 "../src/font-manager/web/google/WebFont.vala"
	_version_length1 = _vala_array_length (_tmp14_);
#line 97 "../src/font-manager/web/google/WebFont.vala"
	__version_size_ = _version_length1;
#line 98 "../src/font-manager/web/google/WebFont.vala"
	_tmp16_ = _version[_version_length1 - 2];
#line 98 "../src/font-manager/web/google/WebFont.vala"
	_tmp17_ = string_replace (_tmp16_, "v", "");
#line 98 "../src/font-manager/web/google/WebFont.vala"
	_tmp18_ = _tmp17_;
#line 98 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_set_version (self, atoi (_tmp18_));
#line 98 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp18_);
#line 82 "../src/font-manager/web/google/WebFont.vala"
	_version = (_vala_array_free (_version, _version_length1, (GDestroyNotify) g_free), NULL);
#line 82 "../src/font-manager/web/google/WebFont.vala"
	block80_data_unref (_data80_);
#line 82 "../src/font-manager/web/google/WebFont.vala"
	_data80_ = NULL;
#line 82 "../src/font-manager/web/google/WebFont.vala"
	return self;
#line 1212 "WebFont.c"
}

FontManagerGoogleFontsFamily*
font_manager_google_fonts_family_new (JsonObject* source)
{
#line 82 "../src/font-manager/web/google/WebFont.vala"
	return font_manager_google_fonts_family_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, source);
#line 1220 "WebFont.c"
}

static Block81Data*
block81_data_ref (Block81Data* _data81_)
{
#line 101 "../src/font-manager/web/google/WebFont.vala"
	g_atomic_int_inc (&_data81_->_ref_count_);
#line 101 "../src/font-manager/web/google/WebFont.vala"
	return _data81_;
#line 1230 "WebFont.c"
}

static void
block81_data_unref (void * _userdata_)
{
	Block81Data* _data81_;
	_data81_ = (Block81Data*) _userdata_;
#line 101 "../src/font-manager/web/google/WebFont.vala"
	if (g_atomic_int_dec_and_test (&_data81_->_ref_count_)) {
#line 1240 "WebFont.c"
		FontManagerGoogleFontsFamily* self;
#line 101 "../src/font-manager/web/google/WebFont.vala"
		self = _data81_->self;
#line 101 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (_data81_->_result_);
#line 101 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self);
#line 101 "../src/font-manager/web/google/WebFont.vala"
		g_slice_free (Block81Data, _data81_);
#line 1250 "WebFont.c"
	}
}

static void
__lambda194_ (Block81Data* _data81_,
              FontManagerGoogleFontsFont* variant)
{
	FontManagerGoogleFontsFamily* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 103 "../src/font-manager/web/google/WebFont.vala"
	self = _data81_->self;
#line 103 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (variant != NULL);
#line 104 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_font_get_italic (variant);
#line 104 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = _tmp0_;
#line 104 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp1_) {
#line 105 "../src/font-manager/web/google/WebFont.vala"
		return;
#line 1275 "WebFont.c"
	}
#line 106 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = font_manager_google_fonts_font_get_weight (variant);
#line 106 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = _tmp2_;
#line 106 "../src/font-manager/web/google/WebFont.vala"
	if (((FontManagerGoogleFontsWeight) _tmp3_) == FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR) {
#line 1283 "WebFont.c"
		FontManagerGoogleFontsFont* _tmp4_;
#line 107 "../src/font-manager/web/google/WebFont.vala"
		_tmp4_ = _g_object_ref0 (variant);
#line 107 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (_data81_->_result_);
#line 107 "../src/font-manager/web/google/WebFont.vala"
		_data81_->_result_ = _tmp4_;
#line 1291 "WebFont.c"
	}
}

static void
___lambda194__gfunc (gconstpointer data,
                     gpointer self)
{
#line 103 "../src/font-manager/web/google/WebFont.vala"
	__lambda194_ (self, (FontManagerGoogleFontsFont*) data);
#line 1301 "WebFont.c"
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_family_get_default_variant (FontManagerGoogleFontsFamily* self)
{
	Block81Data* _data81_;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	FontManagerGoogleFontsFont* _tmp2_;
	GPtrArray* _tmp3_;
	FontManagerGoogleFontsFont* _tmp4_;
	FontManagerGoogleFontsFont* result;
#line 101 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_data81_ = g_slice_new0 (Block81Data);
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_data81_->_ref_count_ = 1;
#line 101 "../src/font-manager/web/google/WebFont.vala"
	_data81_->self = g_object_ref (self);
#line 102 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_variants;
#line 102 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = g_ptr_array_index (_tmp0_, (guint) 0);
#line 102 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = _g_object_ref0 ((FontManagerGoogleFontsFont*) _tmp1_);
#line 102 "../src/font-manager/web/google/WebFont.vala"
	_data81_->_result_ = _tmp2_;
#line 103 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = self->priv->_variants;
#line 103 "../src/font-manager/web/google/WebFont.vala"
	g_ptr_array_foreach (_tmp3_, ___lambda194__gfunc, _data81_);
#line 109 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = _g_object_ref0 (_data81_->_result_);
#line 109 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp4_;
#line 109 "../src/font-manager/web/google/WebFont.vala"
	block81_data_unref (_data81_);
#line 109 "../src/font-manager/web/google/WebFont.vala"
	_data81_ = NULL;
#line 109 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1344 "WebFont.c"
}

static Block82Data*
block82_data_ref (Block82Data* _data82_)
{
#line 112 "../src/font-manager/web/google/WebFont.vala"
	g_atomic_int_inc (&_data82_->_ref_count_);
#line 112 "../src/font-manager/web/google/WebFont.vala"
	return _data82_;
#line 1354 "WebFont.c"
}

static void
block82_data_unref (void * _userdata_)
{
	Block82Data* _data82_;
	_data82_ = (Block82Data*) _userdata_;
#line 112 "../src/font-manager/web/google/WebFont.vala"
	if (g_atomic_int_dec_and_test (&_data82_->_ref_count_)) {
#line 1364 "WebFont.c"
		FontManagerGoogleFontsFamily* self;
#line 112 "../src/font-manager/web/google/WebFont.vala"
		self = _data82_->self;
#line 112 "../src/font-manager/web/google/WebFont.vala"
		_g_string_free0 (_data82_->builder);
#line 112 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self);
#line 112 "../src/font-manager/web/google/WebFont.vala"
		g_slice_free (Block82Data, _data82_);
#line 1374 "WebFont.c"
	}
}

static void
__lambda195_ (Block82Data* _data82_,
              FontManagerGoogleFontsFont* variant)
{
	FontManagerGoogleFontsFamily* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 114 "../src/font-manager/web/google/WebFont.vala"
	self = _data82_->self;
#line 114 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (variant != NULL);
#line 114 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_font_to_font_face_rule (variant);
#line 114 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/font-manager/web/google/WebFont.vala"
	g_string_append (_data82_->builder, _tmp1_);
#line 114 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp1_);
#line 1397 "WebFont.c"
}

static void
___lambda195__gfunc (gconstpointer data,
                     gpointer self)
{
#line 114 "../src/font-manager/web/google/WebFont.vala"
	__lambda195_ (self, (FontManagerGoogleFontsFont*) data);
#line 1406 "WebFont.c"
}

gchar*
font_manager_google_fonts_family_to_stylesheet (FontManagerGoogleFontsFamily* self)
{
	Block82Data* _data82_;
	GString* _tmp0_;
	GPtrArray* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 112 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "../src/font-manager/web/google/WebFont.vala"
	_data82_ = g_slice_new0 (Block82Data);
#line 112 "../src/font-manager/web/google/WebFont.vala"
	_data82_->_ref_count_ = 1;
#line 112 "../src/font-manager/web/google/WebFont.vala"
	_data82_->self = g_object_ref (self);
#line 113 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = g_string_new ("");
#line 113 "../src/font-manager/web/google/WebFont.vala"
	_data82_->builder = _tmp0_;
#line 114 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_variants;
#line 114 "../src/font-manager/web/google/WebFont.vala"
	g_ptr_array_foreach (_tmp1_, ___lambda195__gfunc, _data82_);
#line 115 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = _data82_->builder->str;
#line 115 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 115 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp3_;
#line 115 "../src/font-manager/web/google/WebFont.vala"
	block82_data_unref (_data82_);
#line 115 "../src/font-manager/web/google/WebFont.vala"
	_data82_ = NULL;
#line 115 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1446 "WebFont.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5950 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5951 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5951 "glib-2.0.vapi"
	return result;
#line 1459 "WebFont.c"
}

FontManagerGoogleFontsFileStatus
font_manager_google_fonts_family_get_installation_status (FontManagerGoogleFontsFamily* self)
{
	FontManagerGoogleFontsFileStatus result;
#line 118 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1468 "WebFont.c"
	{
		gint i = 0;
#line 119 "../src/font-manager/web/google/WebFont.vala"
		i = 0;
#line 1473 "WebFont.c"
		{
			gboolean _tmp0_ = FALSE;
#line 119 "../src/font-manager/web/google/WebFont.vala"
			_tmp0_ = TRUE;
#line 119 "../src/font-manager/web/google/WebFont.vala"
			while (TRUE) {
#line 1480 "WebFont.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				FontManagerGoogleFontsFileStatus status = 0;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
#line 119 "../src/font-manager/web/google/WebFont.vala"
				if (!_tmp0_) {
#line 1489 "WebFont.c"
					gint _tmp1_;
#line 119 "../src/font-manager/web/google/WebFont.vala"
					_tmp1_ = i;
#line 119 "../src/font-manager/web/google/WebFont.vala"
					i = _tmp1_ + 1;
#line 1495 "WebFont.c"
				}
#line 119 "../src/font-manager/web/google/WebFont.vala"
				_tmp0_ = FALSE;
#line 119 "../src/font-manager/web/google/WebFont.vala"
				_tmp2_ = self->priv->_variants;
#line 119 "../src/font-manager/web/google/WebFont.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 119 "../src/font-manager/web/google/WebFont.vala"
				_tmp4_ = _tmp3_;
#line 119 "../src/font-manager/web/google/WebFont.vala"
				if (!(i < _tmp4_)) {
#line 119 "../src/font-manager/web/google/WebFont.vala"
					break;
#line 1509 "WebFont.c"
				}
#line 120 "../src/font-manager/web/google/WebFont.vala"
				_tmp5_ = self->priv->_variants;
#line 120 "../src/font-manager/web/google/WebFont.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
#line 120 "../src/font-manager/web/google/WebFont.vala"
				status = font_manager_google_fonts_font_get_installation_status ((FontManagerGoogleFontsFont*) _tmp6_);
#line 121 "../src/font-manager/web/google/WebFont.vala"
				if (status != FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED) {
#line 122 "../src/font-manager/web/google/WebFont.vala"
					result = status;
#line 122 "../src/font-manager/web/google/WebFont.vala"
					return result;
#line 1523 "WebFont.c"
				}
			}
		}
	}
#line 124 "../src/font-manager/web/google/WebFont.vala"
	result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
#line 124 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1532 "WebFont.c"
}

const gchar*
font_manager_google_fonts_family_get_family (FontManagerGoogleFontsFamily* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 75 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_family;
#line 75 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 75 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1548 "WebFont.c"
}

void
font_manager_google_fonts_family_set_family (FontManagerGoogleFontsFamily* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 75 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_family (self);
#line 75 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1562 "WebFont.c"
		gchar* _tmp0_;
#line 75 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strdup (value);
#line 75 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (self->priv->_family);
#line 75 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_family = _tmp0_;
#line 75 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY]);
#line 1572 "WebFont.c"
	}
}

const gchar*
font_manager_google_fonts_family_get_category (FontManagerGoogleFontsFamily* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 76 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_category;
#line 76 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 76 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1589 "WebFont.c"
}

void
font_manager_google_fonts_family_set_category (FontManagerGoogleFontsFamily* self,
                                               const gchar* value)
{
	gchar* old_value;
#line 76 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_category (self);
#line 76 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1603 "WebFont.c"
		gchar* _tmp0_;
#line 76 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strdup (value);
#line 76 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (self->priv->_category);
#line 76 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_category = _tmp0_;
#line 76 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY]);
#line 1613 "WebFont.c"
	}
}

GPtrArray*
font_manager_google_fonts_family_get_variants (FontManagerGoogleFontsFamily* self)
{
	GPtrArray* result;
	GPtrArray* _tmp0_;
#line 77 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_variants;
#line 77 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 77 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1630 "WebFont.c"
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 77 "../src/font-manager/web/google/WebFont.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 1638 "WebFont.c"
}

void
font_manager_google_fonts_family_set_variants (FontManagerGoogleFontsFamily* self,
                                               GPtrArray* value)
{
	GPtrArray* old_value;
#line 77 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_variants (self);
#line 77 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 1652 "WebFont.c"
		GPtrArray* _tmp0_;
#line 77 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = _g_ptr_array_ref0 (value);
#line 77 "../src/font-manager/web/google/WebFont.vala"
		_g_ptr_array_unref0 (self->priv->_variants);
#line 77 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_variants = _tmp0_;
#line 77 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY]);
#line 1662 "WebFont.c"
	}
}

FontManagerStringSet*
font_manager_google_fonts_family_get_subsets (FontManagerGoogleFontsFamily* self)
{
	FontManagerStringSet* result;
	FontManagerStringSet* _tmp0_;
#line 78 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_subsets;
#line 78 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 78 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1679 "WebFont.c"
}

void
font_manager_google_fonts_family_set_subsets (FontManagerGoogleFontsFamily* self,
                                              FontManagerStringSet* value)
{
	FontManagerStringSet* old_value;
#line 78 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_subsets (self);
#line 78 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 1693 "WebFont.c"
		FontManagerStringSet* _tmp0_;
#line 78 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 78 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self->priv->_subsets);
#line 78 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_subsets = _tmp0_;
#line 78 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY]);
#line 1703 "WebFont.c"
	}
}

gint
font_manager_google_fonts_family_get_count (FontManagerGoogleFontsFamily* self)
{
	gint result;
#line 79 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 79 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_count;
#line 79 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1717 "WebFont.c"
}

static void
font_manager_google_fonts_family_set_count (FontManagerGoogleFontsFamily* self,
                                            gint value)
{
	gint old_value;
#line 79 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_count (self);
#line 79 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 79 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_count = value;
#line 79 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY]);
#line 1735 "WebFont.c"
	}
}

gint
font_manager_google_fonts_family_get_version (FontManagerGoogleFontsFamily* self)
{
	gint result;
#line 80 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_version;
#line 80 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 1749 "WebFont.c"
}

static void
font_manager_google_fonts_family_set_version (FontManagerGoogleFontsFamily* self,
                                              gint value)
{
	gint old_value;
#line 80 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_family_get_version (self);
#line 80 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 80 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_version = value;
#line 80 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY]);
#line 1767 "WebFont.c"
	}
}

static void
font_manager_google_fonts_family_class_init (FontManagerGoogleFontsFamilyClass * klass,
                                             gpointer klass_data)
{
#line 73 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_family_parent_class = g_type_class_peek_parent (klass);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsFamily_private_offset);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_family_get_property;
#line 73 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_family_set_property;
#line 73 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_family_finalize;
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY] = g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY] = g_param_spec_string ("category", "category", "category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY] = g_param_spec_boxed ("variants", "variants", "variants", G_TYPE_PTR_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY] = g_param_spec_object ("subsets", "subsets", "subsets", font_manager_string_set_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY] = g_param_spec_int ("count", "count", "count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 73 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY] = g_param_spec_int ("version", "version", "version", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1797 "WebFont.c"
}

static void
font_manager_google_fonts_family_instance_init (FontManagerGoogleFontsFamily * self,
                                                gpointer klass)
{
#line 73 "../src/font-manager/web/google/WebFont.vala"
	self->priv = font_manager_google_fonts_family_get_instance_private (self);
#line 79 "../src/font-manager/web/google/WebFont.vala"
	self->priv->_count = 0;
#line 80 "../src/font-manager/web/google/WebFont.vala"
	self->priv->_version = 1;
#line 1810 "WebFont.c"
}

static void
font_manager_google_fonts_family_finalize (GObject * obj)
{
	FontManagerGoogleFontsFamily * self;
#line 73 "../src/font-manager/web/google/WebFont.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
#line 75 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (self->priv->_family);
#line 76 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (self->priv->_category);
#line 77 "../src/font-manager/web/google/WebFont.vala"
	_g_ptr_array_unref0 (self->priv->_variants);
#line 78 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (self->priv->_subsets);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (font_manager_google_fonts_family_parent_class)->finalize (obj);
#line 1829 "WebFont.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_family_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsFamilyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_family_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsFamily), 0, (GInstanceInitFunc) font_manager_google_fonts_family_instance_init, NULL };
	GType font_manager_google_fonts_family_type_id;
	font_manager_google_fonts_family_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerGoogleFontsFamily", &g_define_type_info, 0);
	FontManagerGoogleFontsFamily_private_offset = g_type_add_instance_private (font_manager_google_fonts_family_type_id, sizeof (FontManagerGoogleFontsFamilyPrivate));
	return font_manager_google_fonts_family_type_id;
}

GType
font_manager_google_fonts_family_get_type (void)
{
	static volatile gsize font_manager_google_fonts_family_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_family_type_id__once)) {
		GType font_manager_google_fonts_family_type_id;
		font_manager_google_fonts_family_type_id = font_manager_google_fonts_family_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_family_type_id__once, font_manager_google_fonts_family_type_id);
	}
	return font_manager_google_fonts_family_type_id__once;
}

static void
_vala_font_manager_google_fonts_family_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	FontManagerGoogleFontsFamily * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	switch (property_id) {
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_family_get_family (self));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_family_get_category (self));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_boxed (value, font_manager_google_fonts_family_get_variants (self));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_object (value, font_manager_google_fonts_family_get_subsets (self));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_int (value, font_manager_google_fonts_family_get_count (self));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_int (value, font_manager_google_fonts_family_get_version (self));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 1900 "WebFont.c"
		default:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 1906 "WebFont.c"
	}
}

static void
_vala_font_manager_google_fonts_family_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	FontManagerGoogleFontsFamily * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
#line 73 "../src/font-manager/web/google/WebFont.vala"
	switch (property_id) {
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_family (self, g_value_get_string (value));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_category (self, g_value_get_string (value));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_variants (self, g_value_get_boxed (value));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_subsets (self, g_value_get_object (value));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_count (self, g_value_get_int (value));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 73 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_family_set_version (self, g_value_get_int (value));
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 1956 "WebFont.c"
		default:
#line 73 "../src/font-manager/web/google/WebFont.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 73 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 1962 "WebFont.c"
	}
}

static inline gpointer
font_manager_google_fonts_font_get_instance_private (FontManagerGoogleFontsFont* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsFont_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1988 "WebFont.c"
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_font_construct (GType object_type,
                                          const gchar* family,
                                          const gchar* variant,
                                          const gchar* url,
                                          FontManagerStringSet* subsets)
{
	FontManagerGoogleFontsFont * self = NULL;
	gboolean _tmp0_ = FALSE;
	gchar** _version = NULL;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _version_length1;
	gint __version_size_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 139 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (family != NULL, NULL);
#line 139 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (variant != NULL, NULL);
#line 139 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 139 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (subsets != NULL, NULL);
#line 140 "../src/font-manager/web/google/WebFont.vala"
	self = (FontManagerGoogleFontsFont*) g_object_new (object_type, "family", family, "url", url, "subsets", subsets, NULL);
#line 141 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_set_italic (self, string_contains (variant, "italic"));
#line 142 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (variant, "regular") == 0) {
#line 142 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = TRUE;
#line 2024 "WebFont.c"
	} else {
#line 142 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strcmp0 (variant, "italic") == 0;
#line 2028 "WebFont.c"
	}
#line 142 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp0_) {
#line 143 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_weight (self, (gint) FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR);
#line 2034 "WebFont.c"
	} else {
		gchar* _tmp1_ = NULL;
		gboolean _tmp2_;
#line 145 "../src/font-manager/web/google/WebFont.vala"
		_tmp2_ = self->priv->_italic;
#line 145 "../src/font-manager/web/google/WebFont.vala"
		if (_tmp2_) {
#line 2042 "WebFont.c"
			gchar* _tmp3_;
#line 145 "../src/font-manager/web/google/WebFont.vala"
			_tmp3_ = string_replace (variant, "italic", "");
#line 145 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (_tmp1_);
#line 145 "../src/font-manager/web/google/WebFont.vala"
			_tmp1_ = _tmp3_;
#line 2050 "WebFont.c"
		} else {
			gchar* _tmp4_;
#line 145 "../src/font-manager/web/google/WebFont.vala"
			_tmp4_ = g_strdup (variant);
#line 145 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (_tmp1_);
#line 145 "../src/font-manager/web/google/WebFont.vala"
			_tmp1_ = _tmp4_;
#line 2059 "WebFont.c"
		}
#line 145 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_weight (self, atoi (_tmp1_));
#line 142 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (_tmp1_);
#line 2065 "WebFont.c"
	}
#line 146 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = _tmp5_ = g_strsplit (url, "/", 0);
#line 146 "../src/font-manager/web/google/WebFont.vala"
	_version = _tmp6_;
#line 146 "../src/font-manager/web/google/WebFont.vala"
	_version_length1 = _vala_array_length (_tmp5_);
#line 146 "../src/font-manager/web/google/WebFont.vala"
	__version_size_ = _version_length1;
#line 147 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = _version[_version_length1 - 2];
#line 147 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = string_replace (_tmp7_, "v", "");
#line 147 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = _tmp8_;
#line 147 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_set_version (self, atoi (_tmp9_));
#line 147 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp9_);
#line 139 "../src/font-manager/web/google/WebFont.vala"
	_version = (_vala_array_free (_version, _version_length1, (GDestroyNotify) g_free), NULL);
#line 139 "../src/font-manager/web/google/WebFont.vala"
	return self;
#line 2089 "WebFont.c"
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_font_new (const gchar* family,
                                    const gchar* variant,
                                    const gchar* url,
                                    FontManagerStringSet* subsets)
{
#line 139 "../src/font-manager/web/google/WebFont.vala"
	return font_manager_google_fonts_font_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, family, variant, url, subsets);
#line 2100 "WebFont.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 2121 "WebFont.c"
}

gchar*
font_manager_google_fonts_font_to_display_name (FontManagerGoogleFontsFont* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* ital = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
#line 150 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_italic;
#line 151 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp1_) {
#line 151 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = _ ("Italic");
#line 2150 "WebFont.c"
	} else {
#line 151 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "";
#line 2154 "WebFont.c"
	}
#line 151 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 151 "../src/font-manager/web/google/WebFont.vala"
	ital = _tmp2_;
#line 152 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = self->priv->_italic;
#line 152 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp4_) {
#line 2164 "WebFont.c"
		gint _tmp5_;
#line 152 "../src/font-manager/web/google/WebFont.vala"
		_tmp5_ = self->priv->_weight;
#line 152 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = _tmp5_ == ((gint) FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR);
#line 2170 "WebFont.c"
	} else {
#line 152 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = FALSE;
#line 2174 "WebFont.c"
	}
#line 152 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp3_) {
#line 153 "../src/font-manager/web/google/WebFont.vala"
		result = ital;
#line 153 "../src/font-manager/web/google/WebFont.vala"
		return result;
#line 2182 "WebFont.c"
	}
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_weight;
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = font_manager_google_fonts_weight_to_translatable_string ((FontManagerGoogleFontsWeight) _tmp6_);
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = _tmp7_;
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = ital;
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = g_strdup_printf ("%s %s", _tmp8_, _tmp9_);
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = _tmp10_;
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = string_strip (_tmp11_);
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp11_);
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp8_);
#line 154 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp13_;
#line 154 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (ital);
#line 154 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2210 "WebFont.c"
}

gchar*
font_manager_google_fonts_font_to_description (FontManagerGoogleFontsFont* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* ital = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
#line 157 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_italic;
#line 158 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp1_) {
#line 158 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "Italic";
#line 2239 "WebFont.c"
	} else {
#line 158 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "";
#line 2243 "WebFont.c"
	}
#line 158 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 158 "../src/font-manager/web/google/WebFont.vala"
	ital = _tmp2_;
#line 159 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = self->priv->_italic;
#line 159 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp4_) {
#line 2253 "WebFont.c"
		gint _tmp5_;
#line 159 "../src/font-manager/web/google/WebFont.vala"
		_tmp5_ = self->priv->_weight;
#line 159 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = ((FontManagerGoogleFontsWeight) _tmp5_) == FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR;
#line 2259 "WebFont.c"
	} else {
#line 159 "../src/font-manager/web/google/WebFont.vala"
		_tmp3_ = FALSE;
#line 2263 "WebFont.c"
	}
#line 159 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp3_) {
#line 160 "../src/font-manager/web/google/WebFont.vala"
		result = ital;
#line 160 "../src/font-manager/web/google/WebFont.vala"
		return result;
#line 2271 "WebFont.c"
	}
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_weight;
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = font_manager_google_fonts_weight_to_string ((FontManagerGoogleFontsWeight) _tmp6_);
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = _tmp7_;
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = ital;
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = g_strdup_printf ("%s %s", _tmp8_, _tmp9_);
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = _tmp10_;
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = string_strip (_tmp11_);
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp11_);
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp8_);
#line 161 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp13_;
#line 161 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (ital);
#line 161 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2299 "WebFont.c"
}

gchar*
font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self)
{
	gchar* description = NULL;
	gchar* _tmp0_;
	gchar* local = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _local = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_ = NULL;
	gboolean _tmp13_;
	gchar* style = NULL;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result;
#line 164 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 165 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_font_to_description (self);
#line 165 "../src/font-manager/web/google/WebFont.vala"
	description = _tmp0_;
#line 166 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_family;
#line 166 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = description;
#line 166 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = g_strdup_printf ("%s %s", _tmp1_, _tmp2_);
#line 166 "../src/font-manager/web/google/WebFont.vala"
	local = _tmp3_;
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = self->priv->_family;
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = string_replace (_tmp4_, " ", "");
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = _tmp5_;
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = description;
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = string_replace (_tmp7_, " ", "");
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = _tmp8_;
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = g_strdup_printf ("%s-%s", _tmp6_, _tmp9_);
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = _tmp10_;
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp9_);
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp6_);
#line 167 "../src/font-manager/web/google/WebFont.vala"
	_local = _tmp11_;
#line 168 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = self->priv->_italic;
#line 168 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp13_) {
#line 168 "../src/font-manager/web/google/WebFont.vala"
		_tmp12_ = "italic";
#line 2373 "WebFont.c"
	} else {
#line 168 "../src/font-manager/web/google/WebFont.vala"
		_tmp12_ = "normal";
#line 2377 "WebFont.c"
	}
#line 168 "../src/font-manager/web/google/WebFont.vala"
	_tmp14_ = g_strdup (_tmp12_);
#line 168 "../src/font-manager/web/google/WebFont.vala"
	style = _tmp14_;
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_tmp15_ = self->priv->_family;
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_tmp16_ = self->priv->_weight;
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_tmp17_ = local;
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_tmp18_ = _local;
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_tmp19_ = self->priv->_url;
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_tmp20_ = g_strdup_printf (FONT_MANAGER_GOOGLE_FONTS_FONT_FACE, _tmp15_, style, _tmp16_, _tmp17_, _tmp18_, _tmp19_);
#line 169 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp20_;
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (style);
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_local);
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (local);
#line 169 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (description);
#line 169 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2407 "WebFont.c"
}

gchar*
font_manager_google_fonts_font_get_filename (FontManagerGoogleFontsFont* self)
{
	gchar* ext = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* style = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* family = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 172 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 173 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_url;
#line 173 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = font_manager_get_file_extension (_tmp0_);
#line 173 "../src/font-manager/web/google/WebFont.vala"
	ext = _tmp1_;
#line 174 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = font_manager_google_fonts_font_to_description (self);
#line 174 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = _tmp2_;
#line 174 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = string_replace (_tmp3_, " ", "_");
#line 174 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = _tmp4_;
#line 174 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp3_);
#line 174 "../src/font-manager/web/google/WebFont.vala"
	style = _tmp5_;
#line 175 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = self->priv->_family;
#line 175 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = string_replace (_tmp6_, " ", "_");
#line 175 "../src/font-manager/web/google/WebFont.vala"
	family = _tmp7_;
#line 176 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = self->priv->_version;
#line 176 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = g_strdup_printf ("%s_%s.%i.%s", family, style, _tmp8_, ext);
#line 176 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp9_;
#line 176 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (family);
#line 176 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (style);
#line 176 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (ext);
#line 176 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2467 "WebFont.c"
}

FontManagerGoogleFontsFileStatus
font_manager_google_fonts_font_get_installation_status (FontManagerGoogleFontsFont* self)
{
	gchar* dir = NULL;
	gchar* _tmp0_;
	gchar* filepath = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* font = NULL;
	const gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* font_dir = NULL;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	FontManagerGoogleFontsFileStatus result;
#line 179 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 180 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = font_manager_google_fonts_get_font_directory ();
#line 180 "../src/font-manager/web/google/WebFont.vala"
	dir = _tmp0_;
#line 181 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = dir;
#line 181 "../src/font-manager/web/google/WebFont.vala"
	_tmp2_ = self->priv->_family;
#line 181 "../src/font-manager/web/google/WebFont.vala"
	_tmp3_ = font_manager_google_fonts_font_get_filename (self);
#line 181 "../src/font-manager/web/google/WebFont.vala"
	_tmp4_ = _tmp3_;
#line 181 "../src/font-manager/web/google/WebFont.vala"
	_tmp5_ = g_build_filename (_tmp1_, _tmp2_, _tmp4_, NULL);
#line 181 "../src/font-manager/web/google/WebFont.vala"
	_tmp6_ = _tmp5_;
#line 181 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp4_);
#line 181 "../src/font-manager/web/google/WebFont.vala"
	filepath = _tmp6_;
#line 182 "../src/font-manager/web/google/WebFont.vala"
	_tmp7_ = filepath;
#line 182 "../src/font-manager/web/google/WebFont.vala"
	_tmp8_ = g_file_new_for_path (_tmp7_);
#line 182 "../src/font-manager/web/google/WebFont.vala"
	font = _tmp8_;
#line 183 "../src/font-manager/web/google/WebFont.vala"
	_tmp9_ = font;
#line 183 "../src/font-manager/web/google/WebFont.vala"
	if (g_file_query_exists (_tmp9_, NULL)) {
#line 184 "../src/font-manager/web/google/WebFont.vala"
		result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED;
#line 184 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (font);
#line 184 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (filepath);
#line 184 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (dir);
#line 184 "../src/font-manager/web/google/WebFont.vala"
		return result;
#line 2537 "WebFont.c"
	}
#line 185 "../src/font-manager/web/google/WebFont.vala"
	_tmp10_ = dir;
#line 185 "../src/font-manager/web/google/WebFont.vala"
	_tmp11_ = self->priv->_family;
#line 185 "../src/font-manager/web/google/WebFont.vala"
	_tmp12_ = g_build_filename (_tmp10_, _tmp11_, NULL);
#line 185 "../src/font-manager/web/google/WebFont.vala"
	_tmp13_ = _tmp12_;
#line 185 "../src/font-manager/web/google/WebFont.vala"
	_tmp14_ = g_file_new_for_path (_tmp13_);
#line 185 "../src/font-manager/web/google/WebFont.vala"
	_tmp15_ = _tmp14_;
#line 185 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (_tmp13_);
#line 185 "../src/font-manager/web/google/WebFont.vala"
	font_dir = _tmp15_;
#line 186 "../src/font-manager/web/google/WebFont.vala"
	_tmp16_ = font_dir;
#line 186 "../src/font-manager/web/google/WebFont.vala"
	if (g_file_query_exists (_tmp16_, NULL)) {
#line 2559 "WebFont.c"
		gchar* ext = NULL;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* style = NULL;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* family = NULL;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* filename = NULL;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gint _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		GFile* outdated = NULL;
		GFile* _tmp30_;
		const gchar* _tmp31_;
		GFile* _tmp32_;
		GFile* _tmp33_;
#line 187 "../src/font-manager/web/google/WebFont.vala"
		_tmp17_ = self->priv->_url;
#line 187 "../src/font-manager/web/google/WebFont.vala"
		_tmp18_ = font_manager_get_file_extension (_tmp17_);
#line 187 "../src/font-manager/web/google/WebFont.vala"
		ext = _tmp18_;
#line 188 "../src/font-manager/web/google/WebFont.vala"
		_tmp19_ = font_manager_google_fonts_font_to_description (self);
#line 188 "../src/font-manager/web/google/WebFont.vala"
		_tmp20_ = _tmp19_;
#line 188 "../src/font-manager/web/google/WebFont.vala"
		_tmp21_ = string_replace (_tmp20_, " ", "_");
#line 188 "../src/font-manager/web/google/WebFont.vala"
		_tmp22_ = _tmp21_;
#line 188 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (_tmp20_);
#line 188 "../src/font-manager/web/google/WebFont.vala"
		style = _tmp22_;
#line 189 "../src/font-manager/web/google/WebFont.vala"
		_tmp23_ = self->priv->_family;
#line 189 "../src/font-manager/web/google/WebFont.vala"
		_tmp24_ = string_replace (_tmp23_, " ", "_");
#line 189 "../src/font-manager/web/google/WebFont.vala"
		family = _tmp24_;
#line 190 "../src/font-manager/web/google/WebFont.vala"
		_tmp25_ = family;
#line 190 "../src/font-manager/web/google/WebFont.vala"
		_tmp26_ = style;
#line 190 "../src/font-manager/web/google/WebFont.vala"
		_tmp27_ = self->priv->_version;
#line 190 "../src/font-manager/web/google/WebFont.vala"
		_tmp28_ = ext;
#line 190 "../src/font-manager/web/google/WebFont.vala"
		_tmp29_ = g_strdup_printf ("%s_%s.%i.%s", _tmp25_, _tmp26_, _tmp27_ - 1, _tmp28_);
#line 190 "../src/font-manager/web/google/WebFont.vala"
		filename = _tmp29_;
#line 191 "../src/font-manager/web/google/WebFont.vala"
		_tmp30_ = font_dir;
#line 191 "../src/font-manager/web/google/WebFont.vala"
		_tmp31_ = filename;
#line 191 "../src/font-manager/web/google/WebFont.vala"
		_tmp32_ = g_file_get_child (_tmp30_, _tmp31_);
#line 191 "../src/font-manager/web/google/WebFont.vala"
		outdated = _tmp32_;
#line 192 "../src/font-manager/web/google/WebFont.vala"
		_tmp33_ = outdated;
#line 192 "../src/font-manager/web/google/WebFont.vala"
		if (g_file_query_exists (_tmp33_, NULL)) {
#line 193 "../src/font-manager/web/google/WebFont.vala"
			result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE;
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (outdated);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (filename);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (family);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (style);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (ext);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (font_dir);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_object_unref0 (font);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (filepath);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			_g_free0 (dir);
#line 193 "../src/font-manager/web/google/WebFont.vala"
			return result;
#line 2652 "WebFont.c"
		}
#line 186 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (outdated);
#line 186 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (filename);
#line 186 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (family);
#line 186 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (style);
#line 186 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (ext);
#line 2664 "WebFont.c"
	}
#line 195 "../src/font-manager/web/google/WebFont.vala"
	result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
#line 195 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (font_dir);
#line 195 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (font);
#line 195 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (filepath);
#line 195 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (dir);
#line 195 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2678 "WebFont.c"
}

const gchar*
font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 131 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 131 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_family;
#line 131 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 131 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2694 "WebFont.c"
}

void
font_manager_google_fonts_font_set_family (FontManagerGoogleFontsFont* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 131 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_family (self);
#line 131 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2708 "WebFont.c"
		gchar* _tmp0_;
#line 131 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strdup (value);
#line 131 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (self->priv->_family);
#line 131 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_family = _tmp0_;
#line 131 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY]);
#line 2718 "WebFont.c"
	}
}

const gchar*
font_manager_google_fonts_font_get_url (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 132 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_url;
#line 132 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 132 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2735 "WebFont.c"
}

void
font_manager_google_fonts_font_set_url (FontManagerGoogleFontsFont* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 132 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_url (self);
#line 132 "../src/font-manager/web/google/WebFont.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2749 "WebFont.c"
		gchar* _tmp0_;
#line 132 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = g_strdup (value);
#line 132 "../src/font-manager/web/google/WebFont.vala"
		_g_free0 (self->priv->_url);
#line 132 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_url = _tmp0_;
#line 132 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY]);
#line 2759 "WebFont.c"
	}
}

gint
font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self)
{
	gint result;
#line 133 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 133 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_weight;
#line 133 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2773 "WebFont.c"
}

void
font_manager_google_fonts_font_set_weight (FontManagerGoogleFontsFont* self,
                                           gint value)
{
	gint old_value;
#line 133 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_weight (self);
#line 133 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 133 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_weight = value;
#line 133 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY]);
#line 2791 "WebFont.c"
	}
}

gboolean
font_manager_google_fonts_font_get_italic (FontManagerGoogleFontsFont* self)
{
	gboolean result;
#line 134 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 134 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_italic;
#line 134 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2805 "WebFont.c"
}

void
font_manager_google_fonts_font_set_italic (FontManagerGoogleFontsFont* self,
                                           gboolean value)
{
	gboolean old_value;
#line 134 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_italic (self);
#line 134 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 134 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_italic = value;
#line 134 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY]);
#line 2823 "WebFont.c"
	}
}

const gchar*
font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
#line 135 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../src/font-manager/web/google/WebFont.vala"
	_tmp1_ = self->priv->_italic;
#line 135 "../src/font-manager/web/google/WebFont.vala"
	if (_tmp1_) {
#line 135 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "italic";
#line 2841 "WebFont.c"
	} else {
#line 135 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = "normal";
#line 2845 "WebFont.c"
	}
#line 135 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 135 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2851 "WebFont.c"
}

gint
font_manager_google_fonts_font_get_version (FontManagerGoogleFontsFont* self)
{
	gint result;
#line 136 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 136 "../src/font-manager/web/google/WebFont.vala"
	result = self->priv->_version;
#line 136 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2864 "WebFont.c"
}

static void
font_manager_google_fonts_font_set_version (FontManagerGoogleFontsFont* self,
                                            gint value)
{
	gint old_value;
#line 136 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_version (self);
#line 136 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 136 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_version = value;
#line 136 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY]);
#line 2882 "WebFont.c"
	}
}

FontManagerStringSet*
font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self)
{
	FontManagerStringSet* result;
	FontManagerStringSet* _tmp0_;
#line 137 "../src/font-manager/web/google/WebFont.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 137 "../src/font-manager/web/google/WebFont.vala"
	_tmp0_ = self->priv->_subsets;
#line 137 "../src/font-manager/web/google/WebFont.vala"
	result = _tmp0_;
#line 137 "../src/font-manager/web/google/WebFont.vala"
	return result;
#line 2899 "WebFont.c"
}

void
font_manager_google_fonts_font_set_subsets (FontManagerGoogleFontsFont* self,
                                            FontManagerStringSet* value)
{
	FontManagerStringSet* old_value;
#line 137 "../src/font-manager/web/google/WebFont.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/font-manager/web/google/WebFont.vala"
	old_value = font_manager_google_fonts_font_get_subsets (self);
#line 137 "../src/font-manager/web/google/WebFont.vala"
	if (old_value != value) {
#line 2913 "WebFont.c"
		FontManagerStringSet* _tmp0_;
#line 137 "../src/font-manager/web/google/WebFont.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 137 "../src/font-manager/web/google/WebFont.vala"
		_g_object_unref0 (self->priv->_subsets);
#line 137 "../src/font-manager/web/google/WebFont.vala"
		self->priv->_subsets = _tmp0_;
#line 137 "../src/font-manager/web/google/WebFont.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY]);
#line 2923 "WebFont.c"
	}
}

static void
font_manager_google_fonts_font_class_init (FontManagerGoogleFontsFontClass * klass,
                                           gpointer klass_data)
{
#line 129 "../src/font-manager/web/google/WebFont.vala"
	font_manager_google_fonts_font_parent_class = g_type_class_peek_parent (klass);
#line 129 "../src/font-manager/web/google/WebFont.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsFont_private_offset);
#line 129 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_font_get_property;
#line 129 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_font_set_property;
#line 129 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_font_finalize;
#line 129 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY] = g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 129 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 129 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY] = g_param_spec_int ("weight", "weight", "weight", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 129 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY] = g_param_spec_boolean ("italic", "italic", "italic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 129 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY] = g_param_spec_string ("style", "style", "style", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 129 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY] = g_param_spec_int ("version", "version", "version", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 129 "../src/font-manager/web/google/WebFont.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY] = g_param_spec_object ("subsets", "subsets", "subsets", font_manager_string_set_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2955 "WebFont.c"
}

static void
font_manager_google_fonts_font_instance_init (FontManagerGoogleFontsFont * self,
                                              gpointer klass)
{
#line 129 "../src/font-manager/web/google/WebFont.vala"
	self->priv = font_manager_google_fonts_font_get_instance_private (self);
#line 136 "../src/font-manager/web/google/WebFont.vala"
	self->priv->_version = 1;
#line 2966 "WebFont.c"
}

static void
font_manager_google_fonts_font_finalize (GObject * obj)
{
	FontManagerGoogleFontsFont * self;
#line 129 "../src/font-manager/web/google/WebFont.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
#line 131 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (self->priv->_family);
#line 132 "../src/font-manager/web/google/WebFont.vala"
	_g_free0 (self->priv->_url);
#line 137 "../src/font-manager/web/google/WebFont.vala"
	_g_object_unref0 (self->priv->_subsets);
#line 129 "../src/font-manager/web/google/WebFont.vala"
	G_OBJECT_CLASS (font_manager_google_fonts_font_parent_class)->finalize (obj);
#line 2983 "WebFont.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_font_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsFontClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_font_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsFont), 0, (GInstanceInitFunc) font_manager_google_fonts_font_instance_init, NULL };
	GType font_manager_google_fonts_font_type_id;
	font_manager_google_fonts_font_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerGoogleFontsFont", &g_define_type_info, 0);
	FontManagerGoogleFontsFont_private_offset = g_type_add_instance_private (font_manager_google_fonts_font_type_id, sizeof (FontManagerGoogleFontsFontPrivate));
	return font_manager_google_fonts_font_type_id;
}

GType
font_manager_google_fonts_font_get_type (void)
{
	static volatile gsize font_manager_google_fonts_font_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_font_type_id__once)) {
		GType font_manager_google_fonts_font_type_id;
		font_manager_google_fonts_font_type_id = font_manager_google_fonts_font_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_font_type_id__once, font_manager_google_fonts_font_type_id);
	}
	return font_manager_google_fonts_font_type_id__once;
}

static void
_vala_font_manager_google_fonts_font_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	FontManagerGoogleFontsFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
#line 129 "../src/font-manager/web/google/WebFont.vala"
	switch (property_id) {
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_font_get_family (self));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_font_get_url (self));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_int (value, font_manager_google_fonts_font_get_weight (self));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_boolean (value, font_manager_google_fonts_font_get_italic (self));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_string (value, font_manager_google_fonts_font_get_style (self));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_int (value, font_manager_google_fonts_font_get_version (self));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		g_value_set_object (value, font_manager_google_fonts_font_get_subsets (self));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 3060 "WebFont.c"
		default:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 3066 "WebFont.c"
	}
}

static void
_vala_font_manager_google_fonts_font_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	FontManagerGoogleFontsFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
#line 129 "../src/font-manager/web/google/WebFont.vala"
	switch (property_id) {
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_family (self, g_value_get_string (value));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_url (self, g_value_get_string (value));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_weight (self, g_value_get_int (value));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_italic (self, g_value_get_boolean (value));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_version (self, g_value_get_int (value));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 129 "../src/font-manager/web/google/WebFont.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		font_manager_google_fonts_font_set_subsets (self, g_value_get_object (value));
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 3116 "WebFont.c"
		default:
#line 129 "../src/font-manager/web/google/WebFont.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 129 "../src/font-manager/web/google/WebFont.vala"
		break;
#line 3122 "WebFont.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

